/*
  File autogenerated by gengetopt version 2.15
  generated with the following command:
  gengetopt --set-version= --set-package= --file-name=oggdec_filter.cmdline --func-name oggdec_cmdline_parser 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "oggdec_filter.cmdline.h"

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
oggdec_cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);


static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->bufsize_given = 0 ;
  args_info->initial_buffer_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->bufsize_arg = 128;
  args_info->bufsize_orig = NULL;
  args_info->initial_buffer_arg = 16;
  args_info->initial_buffer_orig = NULL;
  
}

void
oggdec_cmdline_parser_print_version (void)
{
  printf ("%s %s\n", OGGDEC_CMDLINE_PARSER_PACKAGE, OGGDEC_CMDLINE_PARSER_VERSION);
}

void
oggdec_cmdline_parser_print_help (void)
{
  oggdec_cmdline_parser_print_version ();
  printf("\nUsage:  [OPTIONS]...\n\n");
  printf("%s\n","  -h, --help                    Print help and exit");
  printf("%s\n","  -V, --version                 Print version and exit");
  printf("%s\n","  -b, --bufsize=kilobyte        size of output buffer  (default=`128')");
  printf("%s\n","  -i, --initial_buffer=kilobyte size of initial input buffer  (default=`16')");
  
}

void
oggdec_cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
}

static void
oggdec_cmdline_parser_release (struct gengetopt_args_info *args_info)
{
  
  if (args_info->bufsize_orig)
    {
      free (args_info->bufsize_orig); /* free previous argument */
      args_info->bufsize_orig = 0;
    }
  if (args_info->initial_buffer_orig)
    {
      free (args_info->initial_buffer_orig); /* free previous argument */
      args_info->initial_buffer_orig = 0;
    }
  
  clear_given (args_info);
}

int
oggdec_cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", OGGDEC_CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  if (args_info->help_given) {
    fprintf(outfile, "%s\n", "help");
  }
  if (args_info->version_given) {
    fprintf(outfile, "%s\n", "version");
  }
  if (args_info->bufsize_given) {
    if (args_info->bufsize_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "bufsize", args_info->bufsize_orig);
    } else {
      fprintf(outfile, "%s\n", "bufsize");
    }
  }
  if (args_info->initial_buffer_given) {
    if (args_info->initial_buffer_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "initial_buffer", args_info->initial_buffer_orig);
    } else {
      fprintf(outfile, "%s\n", "initial_buffer");
    }
  }
  
  fclose (outfile);

  i = EXIT_SUCCESS;
  return i;
}

void
oggdec_cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  oggdec_cmdline_parser_release (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
oggdec_cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return oggdec_cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
oggdec_cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = oggdec_cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      oggdec_cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
oggdec_cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name)
{
  return EXIT_SUCCESS;
}

int
oggdec_cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    oggdec_cmdline_parser_init (args_info);

  oggdec_cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "bufsize",	1, NULL, 'b' },
        { "initial_buffer",	1, NULL, 'i' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVb:i:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          oggdec_cmdline_parser_print_help ();
          oggdec_cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          oggdec_cmdline_parser_print_version ();
          oggdec_cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'b':	/* size of output buffer.  */
          if (local_args_info.bufsize_given)
            {
              fprintf (stderr, "%s: `--bufsize' (`-b') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->bufsize_given && ! override)
            continue;
          local_args_info.bufsize_given = 1;
          args_info->bufsize_given = 1;
          args_info->bufsize_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->bufsize_orig)
            free (args_info->bufsize_orig); /* free previous string */
          args_info->bufsize_orig = gengetopt_strdup (optarg);
          break;

        case 'i':	/* size of initial input buffer.  */
          if (local_args_info.initial_buffer_given)
            {
              fprintf (stderr, "%s: `--initial_buffer' (`-i') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->initial_buffer_given && ! override)
            continue;
          local_args_info.initial_buffer_given = 1;
          args_info->initial_buffer_given = 1;
          args_info->initial_buffer_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->initial_buffer_orig)
            free (args_info->initial_buffer_orig); /* free previous string */
          args_info->initial_buffer_orig = gengetopt_strdup (optarg);
          break;


        case 0:	/* Long option with no short option */
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", OGGDEC_CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */




  oggdec_cmdline_parser_release (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  return 0;

failure:
  
  oggdec_cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
